﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Timers;
using TwinCAT.Ads;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        private int hbool1;//main.bool1变量的句柄
        private int hint1;//main.int1变量的句柄
        private int hstr1;//main.str1变量的句柄
        private int hlreal1;//main.lreal1变量的句柄
        private string AMSNETID="127.0.0.1.1.1";//目标的AMSnetid
        private int PORT=851;//目标的端口号
        private TcAdsClient adsClient;//ads客户端
        private ArrayList notificationHandles;//通知句柄
        private int hcomplexStruct;//main.ComplexStruct1的句柄
        Int16[,] Twodimensionalarray = new Int16[3, 3];//二维数组

        //初始化画面
        public Form1()
        {
            InitializeComponent();
            System.Windows.Forms.Control.CheckForIllegalCrossThreadCalls = false;//设置该属性 为false
        }
        //初始化各个控件状态
        private void Form1_Load(object sender, EventArgs e)
        {
            AMSNETID_Box1.Text = AMSNETID;
            PORT_Box1.Text = PORT.ToString();
            Bool_Box1.Text = Int_Box1.Text = Str_Box1.Text = Double_Box1.Text =
                Int_Box2.Text = Str_Box2.Text = StructInt_Box1.Text = "0";

            Disconnect_Button.Enabled = 
                Time_On_Button.Enabled = 
                Time_Off_Button.Enabled = 
                Notification_On_Button.Enabled = 
                Notification_Off_Button.Enabled = 
                Read_Button.Enabled = 
                Write_Button.Enabled = false;

        }

        //Connect按钮按下事件
        private void Connect_Button_Click(object sender, EventArgs e)
        {
            adsClient = new TcAdsClient();
            notificationHandles = new ArrayList();

            Connect_Button.Enabled = 
                Time_Off_Button.Enabled =
                Notification_Off_Button.Enabled = false;
            Disconnect_Button.Enabled = 
                Read_Button.Enabled =
                Write_Button.Enabled = 
                Time_On_Button.Enabled = 
                Notification_On_Button.Enabled = true;


            AMSNETID = AMSNETID_Box1.Text.ToString();//获取框中的netid
            PORT = int.Parse(PORT_Box1.Text);//获取框中的port

            try
            {

                adsClient.AdsNotificationEx += new AdsNotificationExEventHandler(adsClient_AdsNotificationEx);
                adsClient.Connect(AMSNETID, PORT); //此处填写AMSNETID和PORT口
                hbool1 = adsClient.CreateVariableHandle("MAIN.bool1");//获取main.bool1的句柄
                hint1 = adsClient.CreateVariableHandle("MAIN.int1");
                hstr1 = adsClient.CreateVariableHandle("MAIN.str1");
                hlreal1 = adsClient.CreateVariableHandle("MAIN.lreal1");
                hcomplexStruct = adsClient.CreateVariableHandle("MAIN.ComplexStruct1");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        //disconnect按钮，初始化控件状态，释放句柄
        private void Disconnect_Button_Click(object sender, EventArgs e)
        {
            Disconnect_Button.Enabled = 
                Time_On_Button.Enabled = 
                Time_Off_Button.Enabled = 
                Notification_On_Button.Enabled = 
                Notification_Off_Button.Enabled = 
                Read_Button.Enabled =
                Write_Button.Enabled = false;
            Connect_Button.Enabled = true;
            
            Bool_Box1.Text = Int_Box1.Text = Str_Box1.Text = Double_Box1.Text = 
                Int_Box2.Text = Str_Box2.Text = StructInt_Box1.Text = "0";

            adsClient.Dispose();
        }

        //read按钮
        private void Read_Button_Click(object sender, EventArgs e)
        {
            try
            {
                //read by handle
                //the second parameter specifies the type of the variable

                Bool_Box1.Text = adsClient.ReadAny(hbool1, typeof(Boolean)).ToString();
                Int_Box1.Text = adsClient.ReadAny(hint1, typeof(Int16)).ToString();
                Double_Box1.Text = adsClient.ReadAny(hlreal1, typeof(Double)).ToString();
                Str_Box1.Text = adsClient.ReadAny(hstr1, typeof(String), new int[] { 5 }).ToString();
                FillStructControls((ComplexStruct)adsClient.ReadAny(hcomplexStruct, typeof(ComplexStruct)));

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        //write按钮
        private void Write_Button_Click(object sender, EventArgs e)
        {

            try
            {

                adsClient.WriteAny(hbool1, Boolean.Parse(Bool_Box1.Text));
                adsClient.WriteAny(hint1, byte.Parse(Int_Box1.Text));
                adsClient.WriteAny(hstr1, Str_Box1.Text, new int[] { 5 });
                adsClient.WriteAny(hcomplexStruct, GetStructFromControls());
                adsClient.WriteAny(hlreal1, Double.Parse(Double_Box1.Text));
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        //定时器触发的内容
        private void timer1_Tick(object sender, EventArgs e)
        {
            Bool_Box1.Text = adsClient.ReadAny(hbool1, typeof(Boolean)).ToString();
            Int_Box1.Text = adsClient.ReadAny(hint1, typeof(Int16)).ToString();
            Double_Box1.Text = adsClient.ReadAny(hlreal1, typeof(Double)).ToString();
            Str_Box1.Text = adsClient.ReadAny(hstr1, typeof(String), new int[] { 5 }).ToString();
            FillStructControls((ComplexStruct)adsClient.ReadAny(hcomplexStruct, typeof(ComplexStruct)));
        }

        //定时器开启按钮
        private void Time_On_Button_Click(object sender, EventArgs e)
        {
            timer1.Enabled = true;
            Time_On_Button.Enabled = false;
            Time_Off_Button.Enabled = true;
        }

        //定时器关闭按钮
        private void Time_Off_Button_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            Time_On_Button.Enabled = true;
            Time_Off_Button.Enabled = false;
        }

        //用于创建变量的通知句柄
        private void adsClient_AdsNotificationEx(object sender, AdsNotificationExEventArgs e)
        {
            TextBox textBox = (TextBox)e.UserData;
            Type type = e.Value.GetType();
            if (type == typeof(string) || type.IsPrimitive)
                textBox.Text = e.Value.ToString();
            else if (type == typeof(ComplexStruct))
                FillStructControls((ComplexStruct)e.Value);
        }

        //通知开启按钮
        private void Notification_On_Button_Click(object sender, EventArgs e)
        {
            notificationHandles.Clear();
            try
            {
                //register notification            
                notificationHandles.Add(adsClient.AddDeviceNotificationEx("MAIN.int1", AdsTransMode.OnChange, 100, 0, Int_Box1, typeof(Int16)));
                notificationHandles.Add(adsClient.AddDeviceNotificationEx("MAIN.bool1", AdsTransMode.OnChange, 100, 0, Bool_Box1, typeof(Boolean)));
                notificationHandles.Add(adsClient.AddDeviceNotificationEx("MAIN.lreal1", AdsTransMode.OnChange, 100, 0, Double_Box1, typeof(Double)));
                notificationHandles.Add(adsClient.AddDeviceNotificationEx("MAIN.str1", AdsTransMode.OnChange, 100, 0, Str_Box1, typeof(String), new int[] { 5 }));
                notificationHandles.Add(adsClient.AddDeviceNotificationEx("MAIN.complexStruct1", AdsTransMode.OnChange, 100, 0, Int_Box2, typeof(ComplexStruct)));

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            Notification_Off_Button.Enabled = true;
            Notification_On_Button.Enabled = false;
        }

        //删除各个变量的通知句柄
        private void Notification_Off_Button_Click(object sender, EventArgs e)
        {
            //delete registered notifications.
            try
            {
                foreach (int handle in notificationHandles)
                    adsClient.DeleteDeviceNotification(handle);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            notificationHandles.Clear();
            Notification_On_Button.Enabled = true;
            Notification_Off_Button.Enabled = false;
        }

        //将结构体内容，输出到textbox中，结构体中的数组将每一位以逗号分割显示在同一个textbox中
        private void FillStructControls(ComplexStruct structure)
        {
            Int_Box2.Text= structure.boolVal.ToString();
            Str_Box2.Text = structure.stringVal;

            //一维数组
            StructInt_Box1.Text = String.Format("{0:d}, {1:d}, {2:d}, {3:d}", structure.dintArr[0],
                structure.dintArr[1], structure.dintArr[2], structure.dintArr[3]);

            //二维数组
            for (int i = 0; i < 9; i++)
            {
                Twodimensionalarray[i / 3, i % 3] = structure.dintArrtwo[i];
            }
            //实际上和读一维数组是一样的，只不过加个小换算，赋值到二维去
            TwoDimensionalArray_Box1.Text = String.Format("读到的二维数组为\r\n[0.0]:{0:d},\r\n[0.1]:{1:d},\r\n[0.2]:{2:d}," +
                                                                        "\r\n[1.0]:{3:d},\r\n[1.1]:{4:d},\r\n[1.2]:{5:d}," +
                                                                        "\r\n[2.0]:{6:d},\r\n[2.1]:{7:d},\r\n[2.2]:{8:d}",
                                                    Twodimensionalarray[0, 0], Twodimensionalarray[0, 1], Twodimensionalarray[0, 2],
                                                    Twodimensionalarray[1, 0], Twodimensionalarray[1, 1], Twodimensionalarray[1, 2],
                                                    Twodimensionalarray[2, 0], Twodimensionalarray[2, 1], Twodimensionalarray[2, 2]);
        }

        //获取textbox中的变量内容，数组变量是以逗号分割的，所以用split分割将每一位取出
        private ComplexStruct GetStructFromControls()
        {

            ComplexStruct structure = new ComplexStruct();

            structure.boolVal = Boolean.Parse(Int_Box2.Text);
            structure.stringVal = Str_Box2.Text;

            //一维数组
            String[] stringArr = StructInt_Box1.Text.Split(new char[] { ',' });           
            for (int i = 0; i < stringArr.Length; i++)
                structure.dintArr[i] = Int16.Parse(stringArr[i]);

            //二维数组
            String[] stringArrtwo = TwoDimensionalArray_Box1.Text.Split(new char[] { ':', ',' });//提取：，之间的数传到textbox中去
            for (int i = 0; i < (stringArrtwo.Length / 2); i++)
            {
                structure.dintArrtwo[i] = Int16.Parse(stringArrtwo[2 * i + 1]);
            }           
            return structure;
        }

    }

    //声明一个结构体，以1字节的方式对齐
    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public class ComplexStruct
    {
        [MarshalAs(UnmanagedType.I1)]//bool类型占一个字节
        public bool boolVal;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 6)]//string(5)占6个
        public string stringVal = "";
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]//int数组中有4个
        public Int16[] dintArr = new Int16[4];
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 9)]//二维数组一共9个数
        public Int16[] dintArrtwo = new Int16[9];
    }
}